import "package:flutter/material.dart";
import 'package:verttice_ui/src/enums/screen_type_enum.dart';
import 'package:verttice_ui/src/utils/screen_size.dart';
import 'package:verttice_ui/src/widgets/themed_widgets/themed_text.dart';

class ScreenHandler extends StatefulWidget {
  final Widget? mobileWidget;
  final Widget? desktopWidget;
  final bool keepStateAlive;

  const ScreenHandler({
    Key? key,
    this.mobileWidget,
    this.desktopWidget,
    this.keepStateAlive = true,
  }) : super(key: key);

  @override
  _ScreenHandlerState createState() => _ScreenHandlerState();
}

class _ScreenHandlerState extends State<ScreenHandler> {
  @override
  Widget build(BuildContext context) {
    ScreenTypeEnum type = ScreenSizeUtils.screenType(
      context,
    );

    int index = 0;
    if (type == ScreenTypeEnum.mobile) {
      index = 1;
    }
    if (!widget.keepStateAlive) {
      return [
        widget.desktopWidget ??
            const Center(
              child: ThemedText(
                "No Desktop vesion for this page //",
              ),
            ),
        widget.mobileWidget ??
            const Center(
              child: ThemedText(
                "No Mobile vesion for this page //",
              ),
            )
      ][index];
    }
    return IndexedStack(
      index: index,
      children: [
        widget.desktopWidget ??
            const Center(
              child: ThemedText(
                "No Desktop vesion for this page //",
              ),
            ),
        widget.mobileWidget ??
            const Center(
              child: ThemedText(
                "No Mobile vesion for this page //",
              ),
            )
      ],
    );
  }
}
