import "package:flutter/material.dart";
import 'package:verttice_logic/verttice_logic.dart';
import 'package:verttice_ui/src/widgets/files/file_upload_and_view_storage.dart';

class ImageListFormFactory extends StatelessWidget {
  final Future<void> Function({
    required List<FileModel> files,
  }) filesDataCallback;
  final String path;
  final List<FileModel> images;
  final Function(FileModel)? deleteImageCallback;

  const ImageListFormFactory({
    Key? key,
    required this.filesDataCallback,
    required this.path,
    required this.images,
    this.deleteImageCallback,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return FileUploadAndViewStorage(
      filesDataCallback: filesDataCallback,
      path: path,
      files: images,
      deleteImageCallback: deleteImageCallback,
    );
  }
}
