import 'package:verttice_logic/verttice_logic.dart';
import "package:verttice_ui/src/const/box_sizes.dart";
import "package:flutter/material.dart";
import 'package:verttice_ui/src/widgets/files/file_list_view_storage.dart';
import 'package:verttice_ui/src/widgets/files/upload_file.dart';

class FileUploadAndViewStorage extends StatelessWidget {
  final List<FileModel>? files;
  final Function(FileModel)? deleteImageCallback;
  final Future<void> Function({
    required List<FileModel> files,
  }) filesDataCallback;
  final String path;
  final String? buttonText;
  final bool multi;
  final VoidCallback? onDoneUpload;

  const FileUploadAndViewStorage({
    Key? key,
    required this.path,
    required this.filesDataCallback,
    this.files,
    this.deleteImageCallback,
    this.buttonText,
    this.multi = true,
    this.onDoneUpload,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return SizedBox(
      child: Column(
        children: [
          if (files != null && files!.isNotEmpty)
            FileListViewStorage(
              deleteImageCallback: deleteImageCallback,
              files: files ?? [],
            ),
          sizedBoxH4,
          UploadFile(
            multi: multi,
            buttonText: buttonText,
            filesDataCallback: filesDataCallback,
            path: path,
            onDoneUpload: onDoneUpload,
          ),
        ],
      ),
    );
  }
}
