import 'package:pdf/pdf.dart';
import 'package:printing/printing.dart';
import 'package:verttice_logic/verttice_logic.dart';
import 'package:dio/dio.dart';
import "package:flutter/material.dart";
import 'package:verttice_ui/verttice_ui.dart';

class PdfViewerFullPage extends StatefulWidget {
  final String url;
  final String? fileName;
  const PdfViewerFullPage({
    Key? key,
    required this.url,
    this.fileName,
  }) : super(key: key);

  @override
  _PdfViewerFullPageState createState() => _PdfViewerFullPageState();
}

class _PdfViewerFullPageState extends State<PdfViewerFullPage> {
  late String _url;
  @override
  void initState() {
    _url = widget.url;
    super.initState();
  }

  @override
  void didUpdateWidget(covariant PdfViewerFullPage oldWidget) {
    super.didUpdateWidget(oldWidget);
    if (_url != widget.url) {
      _url = widget.url;
    }
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: const ThemedAppBar(),
      body: PdfPreview(
        canChangeOrientation: false,
        pdfFileName: widget.fileName ??
            Dates.formatDataAndTime(
              miliseconds: DateTime.now().millisecondsSinceEpoch,
            ),
        build: (PdfPageFormat pdfPageFormat) async {
          final data = await Dio().get(
            _url,
            options: Options(responseType: ResponseType.bytes),
          );

          return data.data;
        },
      ),
    );
  }
}
