import "package:flutter/material.dart";
import 'package:verttice_ui/verttice_ui.dart';

import 'pdf_viewer_full_page_network.dart';

class PdfViewerNetwork extends StatefulWidget {
  final String url;
  final double? height;
  final String? diaplyName;

  const PdfViewerNetwork({
    Key? key,
    required this.url,
    this.height,
    this.diaplyName,
  }) : super(key: key);

  @override
  _PdfViewerState createState() => _PdfViewerState();
}

class _PdfViewerState extends State<PdfViewerNetwork> {
  late String _url;

  @override
  void initState() {
    _url = widget.url;
    super.initState();
  }

  @override
  void didUpdateWidget(covariant PdfViewerNetwork oldWidget) {
    super.didUpdateWidget(oldWidget);
    if (_url != widget.url) {
      _url = widget.url;
    }
  }

  @override
  Widget build(BuildContext context) {
    return SizedBox(
      height: widget.height ?? MediaQuery.of(context).size.height / 2.5,
      child: InkWell(
        onTap: () async {
          Navigator.push(
            context,
            MaterialPageRoute(
              builder: (context) => PdfViewerFullPage(
                url: _url,
                fileName: widget.diaplyName != null
                    ? widget.diaplyName!.replaceAll(' ', '_')
                    : null,
              ),
            ),
          );
        },
        child: Container(
          decoration: const BoxDecoration(
            borderRadius: BorderRadius.all(
              Radius.circular(5.0),
            ),
            image: DecorationImage(
              image: AssetImage(
                VertticeUIAssets.pdf,
                package: 'verttice_ui',
              ),
              fit: BoxFit.cover,
            ),
          ),
          child: Align(
            alignment: Alignment.bottomCenter,
            child: SelectableText(
              widget.diaplyName ?? "PDF",
              style: const TextStyle(
                color: Colors.black,
              ),
            ),
          ),
        ),
      ),
    );
  }
}
