import 'package:verttice_logic/verttice_logic.dart';
import "package:verttice_ui/src/const/box_sizes.dart";
import "package:flutter/material.dart";
import 'package:verttice_ui/src/widgets/drawing/painter.dart';
import 'package:verttice_ui/src/widgets/themed_widgets/themed_widgets_index.dart';

import 'files/files_index.dart';

class HandSignature extends StatefulWidget {
  final Function(FileModel signature) signatureFileCallback;
  final String? currentSiganturePath;
  final String siganturePath;
  final String sinatureText;

  const HandSignature({
    Key? key,
    required this.signatureFileCallback,
    required this.currentSiganturePath,
    required this.siganturePath,
    this.sinatureText = "Client Signature",
  }) : super(key: key);

  @override
  _HandSignatureState createState() => _HandSignatureState();
}

class _HandSignatureState extends State<HandSignature> {
  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        if (widget.currentSiganturePath != null)
          Center(
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.center,
              children: [
                Padding(
                  padding: const EdgeInsets.all(10),
                  child: SelectableText(
                    widget.sinatureText,
                    style: const TextStyle(
                      fontSize: 17,
                    ),
                  ),
                ),
                Padding(
                    padding: const EdgeInsets.fromLTRB(5, 0, 5, 0),
                    child: SizedBox(
                      height: 150,
                      child: ImageViewerStorage(
                        path: widget.currentSiganturePath ?? "",
                      ),
                    )),
                sizedBoxH4,
              ],
            ),
          ),
        Center(
          child: ThemedTextButton(
            'Hand Siganture',
            onPressed: () {
              Navigator.push(
                context,
                MaterialPageRoute(
                  builder: (context) => Painter(
                    buttonText: "Update ${widget.sinatureText}",
                    imageDataCallback: widget.signatureFileCallback,
                    path: widget.siganturePath,
                  ),
                ),
              );
            },
          ),
        ),
      ],
    );
  }
}
