import 'package:verttice_ui/src/state/verttice_ui_state.dart';
import "package:verttice_ui/src/tools/screen_type.dart";
import "package:flutter/material.dart";
import 'package:provider/provider.dart';

/// if screen id mobile is stay the same otherwise it change to desktop layout
class MobileToDesktopPage extends StatefulWidget {
  final Widget mobilePage;
  final bool contnetOnTheLeft;
  const MobileToDesktopPage({
    Key? key,
    required this.mobilePage,
    this.contnetOnTheLeft = true,
  }) : super(key: key);

  @override
  _MobileToDesktopPageState createState() => _MobileToDesktopPageState();
}

class _MobileToDesktopPageState extends State<MobileToDesktopPage> {
  @override
  Widget build(BuildContext context) {
    final Widget mobilePage = widget.mobilePage;
    final bool contnetOnTheLeft = widget.contnetOnTheLeft;
    return LayoutBuilder(
      builder: (context, constraints) {
        return ScreenHandler(
          keepStateAlive: false,
          mobileWidget: mobilePage,
          desktopWidget: Row(
            children: [
              if (contnetOnTheLeft)
                SizedBox(
                  width: constraints.maxWidth * 0.5,
                  child: mobilePage,
                ),
              Consumer<VertticeUIState>(
                builder: (context, value, _child) {
                  return Container(
                    color: value.themeColor,
                    width: constraints.maxWidth * 0.5,
                    // child: Center(
                    //   child: Consumer<VertticeUIState>(
                    //     builder: (context, value, _child) {
                    //       return Image.asset(
                    //         value.isDarkTheme
                    //             ? "CP12LogoSmallW.png"
                    //             : "CP12LogoSmallB.png",
                    //         height: constraints.maxHeight * 0.3,
                    //       );
                    //     },
                    //   ),
                    // ),
                  );
                },
              ),
              if (!contnetOnTheLeft)
                SizedBox(
                  width: constraints.maxWidth * 0.5,
                  child: mobilePage,
                ),
            ],
          ),
        );
      },
    );
  }
}
