import 'package:flutter/material.dart';
import 'package:flutter_glow/flutter_glow.dart';
import 'package:provider/provider.dart';
import 'package:verttice_ui/verttice_ui.dart';

class ThemedGlowText extends StatelessWidget {
  final String text;
  final Color? glowColor;
  final TextStyle? style;
  final TextOverflow? overflow;
  final int? maxLines;
  const ThemedGlowText(
    this.text, {
    Key? key,
    this.style,
    this.glowColor,
    this.overflow,
    this.maxLines,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Consumer<VertticeUIState>(builder: (context, value, _child) {
      return GlowText(
        text,
        style:
            TextStyle(color: (!value.isDarkTheme ? Colors.white : Colors.black))
                .merge(style),
        overflow: overflow,
        maxLines: maxLines,
        blurRadius: 7,
        glowColor:
            glowColor ?? (value.isDarkTheme ? Colors.white : Colors.black),
      );
    });
  }
}
