import 'package:flutter/material.dart';
import 'package:provider/provider.dart';
import 'package:verttice_ui/src/widgets/custom_switch.dart';
import 'package:verttice_ui/verttice_ui.dart';

class ThemedSwitch extends StatelessWidget {
  const ThemedSwitch({
    Key? key,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Consumer<VertticeUIState>(
      builder: (
        BuildContext context,
        VertticeUIState value,
        Widget? widget,
      ) {
        return CustomSwitch(
          value: value.isDarkTheme,
          switchColor: value.themeColor,
          onChanged: (val) {
            value.setBrightnessTheme(!value.isDarkTheme);
          },
        );
      },
    );
  }
}
