// import "package:verttice_ui/widgets/themed_progress.dart";
import "package:flutter/material.dart";
import "package:webviewx/webviewx.dart";

class WebViewer extends StatefulWidget {
  final double? height;
  final double? width;
  final String? url;
  final String? html;
  WebViewer({
    Key? key,
    this.url,
    this.html,
    this.height,
    this.width,
  }) : super(key: key) {
    assert(url != null || html != null, "url or html must be provied");
  }

  @override
  _ShowPageState createState() => _ShowPageState();
}

class _ShowPageState extends State<WebViewer> {
  // bool _loadingPage = false;

  late WebViewXController _webviewXController;

  @override
  void dispose() {
    _webviewXController.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    if (widget.url != null || widget.html != null) {
      return LayoutBuilder(builder: (context, constraints) {
        final width = widget.width ??
            (constraints.maxWidth != double.infinity
                ? constraints.maxWidth
                : MediaQuery.of(context).size.width);
        final height = widget.height ??
            (constraints.maxHeight != double.infinity
                ? constraints.maxHeight
                : MediaQuery.of(context).size.height);
        return Column(
          mainAxisAlignment: MainAxisAlignment.center,
          crossAxisAlignment: CrossAxisAlignment.center,
          children: [
            // if (_loadingPage)
            //   Column(
            //       mainAxisAlignment: MainAxisAlignment.center,
            //       crossAxisAlignment: CrossAxisAlignment.center,
            //       children: const [
            //         SizedBox(
            //           height: 10,
            //         ),
            //         ThemedProgress(),
            //         SizedBox(
            //           height: 10,
            //         ),
            //       ]),
            SizedBox(
              width: width,
              height: height,
              child: WebViewAware(
                child: WebViewX(
                  width: width,
                  height: height,
                  initialContent: (widget.url ?? widget.html)!,
                  initialSourceType:
                      widget.url != null ? SourceType.url : SourceType.html,
                  onWebViewCreated: (WebViewXController webViewXController) {
                    _webviewXController = webViewXController;
                  },
                ),
              ),
            ),
          ],
        );
      });
    }
    return Container();
  }
}
